## imapsync 1.125

=== Makefile ===

# $Id: Makefile,v 1.7 2005/04/13 11:44:17 gilles Exp gilles $	

TARGET=imapsync

.PHONY: help usage all

help: usage

usage:
	@echo "      $(TARGET) $(VERSION), You can do :"
	@echo make install # as root
	@echo make testf   # run tests
	@echo make testv   # run tests verbosely
	@echo make all     

all: ChangeLog README VERSION

.PHONY: test testp testf

.test: $(TARGET) tests.sh
	sh tests.sh 1>/dev/null
	touch .test

testv:
	sh -x tests.sh

test: .test

testf: clean_test test

testp :
	perl -c $(TARGET)

ChangeLog: $(TARGET)
	rlog $(TARGET) > ChangeLog

README: $(TARGET)
	perldoc -t $(TARGET) > README

VERSION: $(TARGET) Makefile
	./$(TARGET) --version > VERSION

.PHONY: clean clean_tilde clean_test   

clean: clean_tilde clean_test

clean_test:
	rm -f .test

clean_tilde:
	rm -f *~

.PHONY: install dist

install: testp
	cp $(TARGET) $(DESTDIR)/usr/bin/$(TARGET)
	chmod 755 $(DESTDIR)/usr/bin/$(TARGET)

DIST_NAME=$(TARGET)-$(VERSION)
DIST_FILE=$(DIST_NAME).tgz
DEB_FILE=$(DIST_NAME).deb
VERSION=$(shell ./$(TARGET) --version)

dist: cidone test clean clean_dist all INSTALL  
	echo making tarball $(DIST_FILE)
	mkdir -p dist
	mkdir -p ../prepa_dist/$(DIST_NAME)
	rsync -aCv --delete ./  ../prepa_dist/$(DIST_NAME)
	cd ../prepa_dist && tar czfv $(DIST_FILE) $(DIST_NAME)
	cp -f ../prepa_dist/$(DIST_FILE) dist/
	cd dist && md5sum $(DIST_FILE) > $(DIST_FILE).md5
	cd dist && md5sum -c $(DIST_FILE).md5


deb: 
	echo making debball $(DEB_FILE)
	mkdir -p ../prepa_deb
	cd  ../prepa_deb && tar xzvf ../prepa_dist/$(DIST_FILE) &&\
	cd ../prepa_dist/$(DIST_NAME) 

.PHONY: cidone clean_dist

cidone:
	rcsdiff RCS/*

clean_dist:
	rm -f dist/*

# Local goals

.PHONY: lfo niouze

lfo: dist niouze
	rsync -av --delete . \
	/home/gilles/public_html/www.linux-france.org/html/prj/$(TARGET)/
	sh ~/memo/lfo-rsync


niouze: VERSION
	. memo && lfo_announce

## imapsync 1.172

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 
-# $Id: Makefile,v 1.7 2005/04/13 11:44:17 gilles Exp gilles $	
+# $Id: Makefile,v 1.10 2006/03/20 00:35:47 gilles Exp gilles $	
 
 TARGET=imapsync
 
@@ -19,11 +19,11 @@
 .PHONY: test testp testf
 
 .test: $(TARGET) tests.sh
-	sh tests.sh 1>/dev/null
+	nice -40 sh tests.sh 1>/dev/null
 	touch .test
 
 testv:
-	sh -x tests.sh
+	nice -40 sh -x tests.sh
 
 test: .test
 
@@ -99,3 +99,4 @@
 
 niouze: VERSION
 	. memo && lfo_announce
+	. memo && fm_announce

## imapsync 1.182

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 
-# $Id: Makefile,v 1.10 2006/03/20 00:35:47 gilles Exp gilles $	
+# $Id: Makefile,v 1.12 2006/08/01 22:58:42 gilles Exp $	
 
 TARGET=imapsync
 
@@ -69,8 +69,8 @@
 	rsync -aCv --delete ./  ../prepa_dist/$(DIST_NAME)
 	cd ../prepa_dist && tar czfv $(DIST_FILE) $(DIST_NAME)
 	cp -f ../prepa_dist/$(DIST_FILE) dist/
-	cd dist && md5sum $(DIST_FILE) > $(DIST_FILE).md5
-	cd dist && md5sum -c $(DIST_FILE).md5
+	cd dist && md5sum $(DIST_FILE) > md5.txt
+	cd dist && md5sum -c md5.txt
 
 
 deb: 
@@ -94,6 +94,8 @@
 lfo: dist niouze
 	rsync -av --delete . \
 	/home/gilles/public_html/www.linux-france.org/html/prj/$(TARGET)/
+	rsync -av --delete ../prepa_dist/imapsync-*tgz  \
+	/home/gilles/public_html/www.linux-france.org/ftp/prj/$(TARGET)/
 	sh ~/memo/lfo-rsync

## imapsync 1.219

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 
-# $Id: Makefile,v 1.12 2006/08/01 22:58:42 gilles Exp $	
+# $Id: Makefile,v 1.15 2007/02/02 02:03:29 gilles Exp gilles $	
 
 TARGET=imapsync
 
@@ -43,7 +43,7 @@
 
 .PHONY: clean clean_tilde clean_test   
 
-clean: clean_tilde clean_test
+clean: clean_tilde clean_test clean_man
 
 clean_test:
 	rm -f .test
@@ -51,11 +51,21 @@
 clean_tilde:
 	rm -f *~
 
-.PHONY: install dist
+.PHONY: install dist man
 
-install: testp
-	cp $(TARGET) $(DESTDIR)/usr/bin/$(TARGET)
+man: $(TARGET).1
+
+clean_man:
+	rm -f $(TARGET).1
+
+$(TARGET).1: $(TARGET)
+	pod2man $(TARGET) > $(TARGET).1
+
+install: testp $(TARGET).1
+	install -D $(TARGET) $(DESTDIR)/usr/bin/$(TARGET)
+	install -D $(TARGET).1 $(DESTDIR)/usr/share/man/man1/$(TARGET).1
 	chmod 755 $(DESTDIR)/usr/bin/$(TARGET)
+
 
 DIST_NAME=$(TARGET)-$(VERSION)
 DIST_FILE=$(DIST_NAME).tgz
@@ -91,14 +101,20 @@
 
 .PHONY: lfo niouze
 
-lfo: dist niouze
+lfo: dist niouze_lfo lfo_upload niouze
+
+lfo_upload: 
 	rsync -av --delete . \
 	/home/gilles/public_html/www.linux-france.org/html/prj/$(TARGET)/
 	rsync -av --delete ../prepa_dist/imapsync-*tgz  \
 	/home/gilles/public_html/www.linux-france.org/ftp/prj/$(TARGET)/
 	sh ~/memo/lfo-rsync
 
+niouze_lfo : VERSION
+	. memo && lfo_announce
 
 niouze: VERSION
-	. memo && lfo_announce
 	. memo && fm_announce
+
+
+public: niouze

## imapsync 1.241

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 
-# $Id: Makefile,v 1.15 2007/02/02 02:03:29 gilles Exp gilles $	
+# $Id: Makefile,v 1.17 2007/10/30 00:49:43 gilles Exp gilles $	
 
 TARGET=imapsync
 
@@ -76,11 +76,11 @@
 	echo making tarball $(DIST_FILE)
 	mkdir -p dist
 	mkdir -p ../prepa_dist/$(DIST_NAME)
-	rsync -aCv --delete ./  ../prepa_dist/$(DIST_NAME)
+	rsync -aCv --delete  --exclude dist/ ./  ../prepa_dist/$(DIST_NAME)
 	cd ../prepa_dist && tar czfv $(DIST_FILE) $(DIST_NAME)
-	cp -f ../prepa_dist/$(DIST_FILE) dist/
-	cd dist && md5sum $(DIST_FILE) > md5.txt
-	cd dist && md5sum -c md5.txt
+	ln -f ../prepa_dist/$(DIST_FILE) dist/
+	cd dist && md5sum $(DIST_FILE) > $(DIST_FILE).md5.txt
+	cd dist && md5sum -c $(DIST_FILE).md5.txt
 
 
 deb: 
@@ -95,7 +95,7 @@
 	rcsdiff RCS/*
 
 clean_dist:
-	rm -f dist/*
+	echo Used to be 'rm -f dist/*'
 
 # Local goals
 
@@ -104,9 +104,9 @@
 lfo: dist niouze_lfo lfo_upload niouze
 
 lfo_upload: 
-	rsync -av --delete . \
+	rsync -avH --delete . \
 	/home/gilles/public_html/www.linux-france.org/html/prj/$(TARGET)/
-	rsync -av --delete ../prepa_dist/imapsync-*tgz  \
+	rsync -avH --delete ../prepa_dist/imapsync-*tgz  \
 	/home/gilles/public_html/www.linux-france.org/ftp/prj/$(TARGET)/
 	sh ~/memo/lfo-rsync

## imapsync 1.286

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 
-# $Id: Makefile,v 1.17 2007/10/30 00:49:43 gilles Exp gilles $	
+# $Id: Makefile,v 1.23 2009/07/03 01:01:13 gilles Exp gilles $	
 
 TARGET=imapsync
 
@@ -9,23 +9,46 @@
 
 usage:
 	@echo "      $(TARGET) $(VERSION), You can do :"
-	@echo make install # as root
-	@echo make testf   # run tests
-	@echo make testv   # run tests verbosely
-	@echo make all     
+	@echo "make install # as root"
+	@echo "make testf   # run tests"
+	@echo "make testv   # run tests verbosely"
+	@echo "make test3xx # run tests with Mail-IMAPClient-3.xy"
+	@echo "make test229 # run tests with Mail-IMAPClient-2.2.9"
+	@echo "make all     "
 
 all: ChangeLog README VERSION
 
-.PHONY: test testp testf
+.PHONY: test testp testf test3xx
 
 .test: $(TARGET) tests.sh
-	nice -40 sh tests.sh 1>/dev/null
+	/usr/bin/time sh tests.sh 1>/dev/null
 	touch .test
+
+.test_3xx: $(TARGET) tests.sh
+	CMD_PERL='perl -I./Mail-IMAPClient-3.19/lib' /usr/bin/time sh tests.sh 1>/dev/null
+	touch .test_3xx
+
+test_quick : test_quick_229 test_quick_3xx
+
+test_quick_229: $(TARGET) tests.sh
+	CMD_PERL='perl -I./Mail-IMAPClient-2.2.9' /usr/bin/time sh tests.sh locallocal 1>/dev/null
+
+test_quick_3xx: $(TARGET) tests.sh
+	CMD_PERL='perl -I./Mail-IMAPClient-3.19/lib' /usr/bin/time sh tests.sh locallocal 1>/dev/null
 
 testv:
 	nice -40 sh -x tests.sh
 
-test: .test
+test: .test_229 .test_3xx
+
+
+test3xx: .test_3xx
+
+test229: .test_229
+
+.test_229: $(TARGET) tests.sh
+	CMD_PERL='perl -I./Mail-IMAPClient-2.2.9' /usr/bin/time sh tests.sh 1>/dev/null
+	touch .test_229
 
 testf: clean_test test
 
@@ -39,14 +62,14 @@
 	perldoc -t $(TARGET) > README
 
 VERSION: $(TARGET) Makefile
-	./$(TARGET) --version > VERSION
+	perl -I./Mail-IMAPClient-2.2.9 ./$(TARGET) --version > VERSION
 
 .PHONY: clean clean_tilde clean_test   
 
-clean: clean_tilde clean_test clean_man
+clean: clean_tilde clean_man
 
 clean_test:
-	rm -f .test
+	rm -f .test .test_3xx .test_229
 
 clean_tilde:
 	rm -f *~
@@ -70,14 +93,17 @@
 DIST_NAME=$(TARGET)-$(VERSION)
 DIST_FILE=$(DIST_NAME).tgz
 DEB_FILE=$(DIST_NAME).deb
-VERSION=$(shell ./$(TARGET) --version)
+VERSION=$(shell perl -I./Mail-IMAPClient-2.2.9 ./$(TARGET) --version)
 
-dist: cidone test clean clean_dist all INSTALL  
+dist: cidone test clean clean_dist all INSTALL tarball
+
+
+tarball:
 	echo making tarball $(DIST_FILE)
 	mkdir -p dist
 	mkdir -p ../prepa_dist/$(DIST_NAME)
 	rsync -aCv --delete  --exclude dist/ ./  ../prepa_dist/$(DIST_NAME)
-	cd ../prepa_dist && tar czfv $(DIST_FILE) $(DIST_NAME)
+	cd ../prepa_dist && tar czfv --verify $(DIST_FILE) $(DIST_NAME)
 	ln -f ../prepa_dist/$(DIST_FILE) dist/
 	cd dist && md5sum $(DIST_FILE) > $(DIST_FILE).md5.txt
 	cd dist && md5sum -c $(DIST_FILE).md5.txt
@@ -86,7 +112,7 @@
 deb: 
 	echo making debball $(DEB_FILE)
 	mkdir -p ../prepa_deb
-	cd  ../prepa_deb && tar xzvf ../prepa_dist/$(DIST_FILE) &&\
+	cd  ../prepa_deb && tar  xzvf ../prepa_dist/$(DIST_FILE) &&\
 	cd ../prepa_dist/$(DIST_NAME) 
 
 .PHONY: cidone clean_dist
@@ -101,7 +127,7 @@
 
 .PHONY: lfo niouze
 
-lfo: dist niouze_lfo lfo_upload niouze
+lfo: dist lfo_upload niouze_lfo  niouze
 
 lfo_upload: 
 	rsync -avH --delete . \

## imapsync 1.315+dfsg

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 
-# $Id: Makefile,v 1.23 2009/07/03 01:01:13 gilles Exp gilles $	
+# $Id: Makefile,v 1.29 2010/06/11 02:51:20 gilles Exp gilles $	
 
 TARGET=imapsync
 
@@ -12,20 +12,20 @@
 	@echo "make install # as root"
 	@echo "make testf   # run tests"
 	@echo "make testv   # run tests verbosely"
-	@echo "make test3xx # run tests with Mail-IMAPClient-3.xy"
+	@echo "make test3xx # run tests with (last) Mail-IMAPClient-3.xy"
 	@echo "make test229 # run tests with Mail-IMAPClient-2.2.9"
 	@echo "make all     "
 
 all: ChangeLog README VERSION
 
-.PHONY: test testp testf test3xx
+.PHONY: test tests testp testf test3xx
 
 .test: $(TARGET) tests.sh
 	/usr/bin/time sh tests.sh 1>/dev/null
 	touch .test
 
 .test_3xx: $(TARGET) tests.sh
-	CMD_PERL='perl -I./Mail-IMAPClient-3.19/lib' /usr/bin/time sh tests.sh 1>/dev/null
+	CMD_PERL='perl -I./Mail-IMAPClient-3.25/lib' /usr/bin/time sh tests.sh 1>/dev/null
 	touch .test_3xx
 
 test_quick : test_quick_229 test_quick_3xx
@@ -34,13 +34,14 @@
 	CMD_PERL='perl -I./Mail-IMAPClient-2.2.9' /usr/bin/time sh tests.sh locallocal 1>/dev/null
 
 test_quick_3xx: $(TARGET) tests.sh
-	CMD_PERL='perl -I./Mail-IMAPClient-3.19/lib' /usr/bin/time sh tests.sh locallocal 1>/dev/null
+	CMD_PERL='perl -I./Mail-IMAPClient-3.25/lib' /usr/bin/time sh tests.sh locallocal 1>/dev/null
 
 testv:
 	nice -40 sh -x tests.sh
 
 test: .test_229 .test_3xx
 
+tests: test
 
 test3xx: .test_3xx
 
@@ -102,8 +103,9 @@
 	echo making tarball $(DIST_FILE)
 	mkdir -p dist
 	mkdir -p ../prepa_dist/$(DIST_NAME)
-	rsync -aCv --delete  --exclude dist/ ./  ../prepa_dist/$(DIST_NAME)
-	cd ../prepa_dist && tar czfv --verify $(DIST_FILE) $(DIST_NAME)
+	rsync -aCv --delete --omit-dir-times --exclude dist/ ./  ../prepa_dist/$(DIST_NAME)
+	#sync && sync && sync && sleep 2
+	cd ../prepa_dist &&  (tar czfv $(DIST_FILE) $(DIST_NAME) || tar czfv  $(DIST_FILE) $(DIST_NAME))
 	ln -f ../prepa_dist/$(DIST_FILE) dist/
 	cd dist && md5sum $(DIST_FILE) > $(DIST_FILE).md5.txt
 	cd dist && md5sum -c $(DIST_FILE).md5.txt
@@ -125,9 +127,9 @@
 
 # Local goals
 
-.PHONY: lfo niouze
+.PHONY: lfo lfo_upload niouze_lfo niouze_fm public
 
-lfo: dist lfo_upload niouze_lfo  niouze
+lfo: dist lfo_upload niouze_lfo
 
 lfo_upload: 
 	rsync -avH --delete . \
@@ -139,8 +141,8 @@
 niouze_lfo : VERSION
 	. memo && lfo_announce
 
-niouze: VERSION
+niouze_fm: VERSION
 	. memo && fm_announce
 
 
-public: niouze
+public: niouze_fm

## imapsync 2.229

=== Makefile ===

# $Id: Makefile,v 1.349 2022/09/15 08:43:25 gilles Exp gilles $	

.PHONY: help usage all doc

help: usage

usage:
	@echo "     this is imapsync $(VERSION), You can do :"
	@echo "make testp   # it shows needed Perl modules from your distro or CPAN"
	@echo "make install # as root"
	@echo ""
	@echo "All other goals are for the upstream developper"

	@echo "make testf      # run tests"
	@echo "make testv      # run tests verbosely"
	@echo "make test_quick # few tests verbosely"
	@echo "make win32testsbat         # run --tests and W/test.bat on win32"
	@echo "make win32tests            # run --tests        on win32"
	@echo "make win32testsdebug       # run --testsdebug   on win32"
	@echo "make W/test2.bat           # run W/test2.bat    on win32"
	@echo "make W/test3.bat           # run W/test3.bat    on win32"
	@echo "make W/test_reg.bat        # run W/test_reg.bat on win32"
	@echo "make W/test_exe.bat        # run W/test_exe.bat on win32"
	@echo "make W/test_exe_tests.bat  # run W/test_exe_tests.bat on win32"
	@echo "make W/test_exe_2.bat      # run W/test_exe_2.bat on win32"
	@echo "make examples/sync_loop_windows.bat # run examples/sync_loop_windows.bat on win32"
        
	@echo "make W/install_modules.bat # run W/install_modules.bat on win32"
	@echo "make W/install_module_one.bat # run W/install_module_one.bat on win32"
	@echo "make W/install_module_ssl.bat # run W/install_module_ssl.bat on win32"
	@echo "make all     "
	@echo "make upload_tests # upload tests.sh"
	@echo "make upload_index"
	@echo "make upload_FAQ    # upload FAQs and documentation"
	@echo "make upload_X      # upload online UI"
	@echo "make upload_csv    # upload online CSV service"
	@echo "make upload_latest # upload latest imapsync and binaries (dev)" 
	@echo "make upload_cgi    # upload latest imapsync online, after local and remote --tests success." 
	@echo "make upload_cgi_memo  # upload cgi_memo stat_patterns.txt to /X servers." 
	@echo "make valid_index # check index.shtml for good syntax"
	@echo "make upload_ks"
	@echo "make imapsync.exe"
	@echo "make bin           # build mac & win & linux binaries"
	@echo "make mac           # build mac binary"
	@echo "make win           # build win binary"
	@echo "make lin           # build linux binary"
	@echo "make publish"
	@echo "make crit          # run perlcritic on imapsync"
	@echo "make prereq # Generates W/prereq.*"
	@echo "make cl # Check links of index.shtml"
	@echo "make cle # Check links of S/*.shtml" 
	@echo "make mactestsdebug # run ./imapsync --testsdebug on Mac"
	@echo "make mactests      # run ./imapsync --tests      on Mac"
	@echo "make mactestslive  # run ./imapsync --testslive  on Mac"
	@echo "make ks5testsdebug # run ./imapsync --testsdebug on ks5"
	@echo "make ks5tests      # run ./imapsync --tests      on ks5"
	@echo "make ks5testslive  # run ./imapsync --testslive  on ks5"


PREFIX ?= /usr
DIST_PATH := dist2/
VERSION := $(shell perl ./imapsync --version 2>/dev/null || cat VERSION)
VERSION_PREVIOUS := $(shell perl ./$(DIST_PATH)/imapsync --version 2>/dev/null || echo ERROR)


DIST_NAME := imapsync-$(VERSION)
DIST_FILE := $(DIST_NAME).tgz
DEB_FILE  := $(DIST_NAME).deb

HELLO := $(shell date;uname -a)

HOSTNAME := $(shell hostname -s)
ARCH     := $(shell uname -m)
KERNEL   := $(shell uname -s)
BIN_NAME := imapsync_bin_$(KERNEL)_$(ARCH)
DISTRO_NAME := $(shell lsb_release -i -s || echo Unknown)
DISTRO_RELEASE := $(shell lsb_release -r -s || echo 0.0)
DISTRO_CODE := $(shell lsb_release -c -s || echo Unknown)
DISTRO := $(DISTRO_NAME)_$(DISTRO_RELEASE)_$(DISTRO_CODE)

hello:
	@echo "VERSION          $(VERSION)"
	@echo "DIST_NAME        $(DIST_NAME)"
	@echo "VERSION_PREVIOUS $(VERSION_PREVIOUS)"
	@echo "HOSTNAME         $(HOSTNAME)"
	@echo "ARCH             $(ARCH)"
	@echo "KERNEL           $(KERNEL)"
	@echo "BIN_NAME         $(BIN_NAME)"
	@echo "DISTRO           $(DISTRO)"


all: doc VERSION biz prereq allcritic 

testp:
	sh INSTALL.d/prerequisites_imapsync
	@perl -c imapsync || { echo; echo "Read the INSTALL file to solve Perl module dependencies!"; exit 1; }

ChangeLog: imapsync
	rlog imapsync > ChangeLog

README: imapsync
	pod2text --loose imapsync > README
	chmod -x README

VERSION: imapsync
	rcsdiff imapsync
	./imapsync --version > ./VERSION
	touch -r ./imapsync ./VERSION


doc/GOOD_PRACTICES.html: doc/GOOD_PRACTICES.t2t
	txt2tags -i doc/GOOD_PRACTICES.t2t  -t html --toc  -o doc/GOOD_PRACTICES.html
	./W/tools/validate_html4 doc/GOOD_PRACTICES.html
	./W/tools/validate       doc/GOOD_PRACTICES.html


doc/TUTORIAL_Unix.html: doc/TUTORIAL_Unix.t2t
	txt2tags -i doc/TUTORIAL_Unix.t2t -t html --toc  -o doc/TUTORIAL_Unix.html
	./W/tools/validate_html4 doc/TUTORIAL_Unix.html
	./W/tools/validate       doc/TUTORIAL_Unix.html


doc:  README  ChangeLog doc/TUTORIAL_Unix.html doc/GOOD_PRACTICES.html W/imapsync.1 

.PHONY: clean clean_tilde clean_test doc clean_log clean_bak clean_permissions clean_oauth2

clean: clean_tilde clean_man clean_log clean_bak clean_permissions clean_oauth2

clean_permissions:
	chmod a-x Makefile FAQ.d/FAQ.*.txt README_Windows.txt
	chmod a-x FAQ.d/RCS/FAQ.*.txt,v
	chmod a-x INSTALL.d/INSTALL.*.txt 
	chmod a-x X/progress.html X/imapsync_form.html 
	chmod a-x S/*.shtml S/*.html  index.shtml S/RCS/*.shtml,v S/RCS/*.html,v 
	chmod a-x doc/*.t2t $(DIST_PATH)/*.txt

clean_test:
	rm -f .test_3xx

clean_tilde:
	rm -f *~ W/*~ FAQ.d/*~ S/*~ INSTALL.d/*~ examples/*~

clean_log:
	rm -f LOG_imapsync/*.txt
	rm -f examples/LOG_imapsync/*.txt

clean_bak:
	rm -f index.shtml.bak ./S/style.css.bak

clean_oauth2:
	rm -f oauth2/typescript oauth2/D_*txt

.PHONY: install dist man

man:  W/imapsync.1

clean_man:
	rm -f  W/imapsync.1

W/imapsync.1: imapsync
	mkdir -p W
	pod2man imapsync > W/imapsync.1

install: testp W/imapsync.1
	mkdir -p $(DESTDIR)$(PREFIX)/bin
	install imapsync $(DESTDIR)$(PREFIX)/bin/imapsync
	chmod 755 $(DESTDIR)$(PREFIX)/bin/imapsync
	mkdir -p $(DESTDIR)$(PREFIX)/share/man/man1
	install W/imapsync.1 $(DESTDIR)$(PREFIX)/share/man/man1/imapsync.1
	chmod 644 $(DESTDIR)$(PREFIX)/share/man/man1/imapsync.1

###############
# Local goals
###############

.PHONY: dailybuild dailytests prereq test tests unitests testp testf test3xx perlcritic allcritic crit compok dev cover tidy nytprof functree

dev: test functree crit cover nytprof bin


dailytests: linuxtests win32tests win64tests mactests

dailybuild: linuxbuild win32build win64build macbuild

linuxtests:
	./imapsync --tests

linuxtestsdebug:
	./imapsync --testsdebug

testsdebug: linuxtestsdebug win64testsdebug win32testsdebug mactestsdebug 

testslive:  mactestslive




docker:
	@echo "make docker_copy_to_vp3 # copy imapsync Dockerfile memo_docker to vp3"
	@echo "make docker_build       # build the imapsync docker image"
	@echo "make docker_upload_docker_hub  # upload last build to https://hub.docker.com/r/gilleslamiral/imapsync"
	@echo "ssh vp3 THEN cd docker/imapsync && . memo_docker"

docker_build: docker_copy_to_vp3
	ssh vp3 'cd docker/imapsync && . memo_docker && imapsync_docker_build'


docker_copy_to_vp3:
	ssh vp3 'mkdir -p docker/imapsync/ var/pass/'
	rsync -av /g/var/pass/secret.docker vp3:var/pass/secret.docker
	rsync -av imapsync INSTALL.d/Dockerfile INSTALL.d/memo_docker INSTALL.d/prerequisites_imapsync INSTALL.d/secret.txt vp3:docker/imapsync/
	rsync -av RCS/imapsync,v INSTALL.d/RCS/Dockerfile,v INSTALL.d/RCS/memo_docker,v vp3:docker/imapsync/RCS/

docker_upload_docker_hub: docker_build
	ssh vp3 'cd docker/imapsync && . memo_docker && imapsync_docker_upload'

functree: W/imapsync_functions_tree_ppi.txt W/imapsync_functions_tree.txt

W/imapsync_functions_tree_ppi.txt: imapsync
	perl ./W/learn/function_calls_ppi ./imapsync > W/imapsync_functions_tree_ppi.txt
	rcsdiff W/imapsync_functions_tree_ppi.txt || { echo 'rcsdiff detected a diff' | ci -l W/imapsync_functions_tree_ppi.txt ; }

W/imapsync_functions_tree.txt: imapsync
	perl ./W/learn/function_calls ./imapsync > W/imapsync_functions_tree.txt
	rcsdiff W/imapsync_functions_tree.txt || { echo 'rcsdiff detected a diff' | ci -l W/imapsync_functions_tree.txt ; }


nytprof: nytprof_clean
	sh tests.sh ll_nytprof
	nytprofhtml

nytprof_clean:
	rm -rfv nytprof/


cover:
	perl -c ./imapsync
	perl -MDevel::Cover ./imapsync --tests --testslive
	cover

tidy: W/imapsync.tdy


W/imapsync.tdy: imapsync
	perltidy -i=8 -sts -pt=0 -l=0 -o W/imapsync.tdy   imapsync 

compok: W/.compok


W/.compok: imapsync
	perl -c imapsync
	date >> W/.compok

prereq: W/prereq.scandeps.$(DISTRO).txt W/prereq.$(DISTRO).txt

W/prereq.scandeps.$(DISTRO).txt: INSTALL.d/prerequisites_imapsync imapsync
	scandeps -c -x  imapsync | tee W/prereq.scandeps.$(DISTRO).txt
	rcsdiff W/prereq.scandeps.$(DISTRO).txt || { echo 'rcsdiff detected a diff' | ci -l W/prereq.scandeps.$(DISTRO).txt ; }

W/prereq.$(DISTRO).txt: INSTALL.d/prerequisites_imapsync imapsync
	./INSTALL.d/prerequisites_imapsync | tee W/prereq.$(DISTRO).txt
	rcsdiff W/prereq.$(DISTRO).txt || { echo 'rcsdiff detected a diff' | ci -l W/prereq.$(DISTRO).txt ; }


crit: allcritic

perlcritic: W/perlcritic_3.txt W/perlcritic_2.txt 

allcritic: W/perlcritic_4.txt W/perlcritic_3.txt W/perlcritic_2.txt W/perlcritic_1.txt

W/perlcritic_1.txt: imapsync W/.compok 
	perlcritic --statistics -1 imapsync > W/perlcritic_1.txt.tmp || :
	mv W/perlcritic_1.txt.tmp W/perlcritic_1.txt
	echo | ci -l W/perlcritic_1.txt

W/perlcritic_2.txt: imapsync W/.compok
	perlcritic --statistics-only -2 imapsync > W/perlcritic_2.txt.tmp || :
	mv W/perlcritic_2.txt.tmp W/perlcritic_2.txt
	echo | ci -l W/perlcritic_2.txt

W/perlcritic_3.txt: imapsync W/.compok
	perlcritic --statistics-only -3 imapsync > W/perlcritic_3.txt.tmp || :
	mv W/perlcritic_3.txt.tmp W/perlcritic_3.txt
	echo | ci -l W/perlcritic_3.txt

W/perlcritic_4.txt: imapsync W/.compok
	perlcritic --statistics -4 imapsync > W/perlcritic_4.txt.tmp || :
	mv W/perlcritic_4.txt.tmp W/perlcritic_4.txt
	echo | ci -l W/perlcritic_4.txt


test_quick: imapsync tests.sh
	/usr/bin/time sh -x tests.sh locallocal

testv: imapsync tests.sh
	/usr/bin/time sh tests.sh

tests: test

test: .tests_passed

# .tests_passed is created by tests.sh with success at all mandatory tests
.tests_passed: imapsync
	/usr/bin/time sh tests.sh 1>/dev/null

unitests: 
	./imapsync --tests


testf: clean_test test

.PHONY: dosify_bat

dosify_bat:
	unix2dos W/*.bat examples/*.bat 

copy_win32:
	scp imapsync Admin@c:'C:/msys/1.0/home/Admin/imapsync/'

.PHONY: win32testsbat win32tests win32testsdebug

win32testsbat:
	unix2dos W/test.bat
	scp imapsync W/test.bat Admin@c:'C:/msys/1.0/home/Admin/imapsync/'
#	ssh Admin@c 'perl C:/msys/1.0/home/Admin/imapsync/imapsync --testsdebug'
	ssh Admin@c 'perl C:/msys/1.0/home/Admin/imapsync/imapsync --tests'
	ssh Admin@c 'C:/msys/1.0/home/Admin/imapsync/test.bat'
#	ssh Admin@c 'tasklist /FI "PID eq 0"' 
#	ssh Admin@c 'tasklist /NH /FO CSV' 


win32tests:
	unix2dos  W/test_tests.bat
	scp imapsync W/test_tests.bat Admin@c:'C:/msys/1.0/home/Admin/imapsync/'
	ssh Admin@c 'C:/msys/1.0/home/Admin/imapsync/test_tests.bat'
	./W/check_winerr test_tests.bat

win32testsdebug:
	unix2dos  W/test_testsdebug.bat
	scp imapsync W/test_testsdebug.bat Admin@c:'C:/msys/1.0/home/Admin/imapsync/'
	ssh Admin@c 'C:/msys/1.0/home/Admin/imapsync/test_testsdebug.bat'
	./W/check_winerr test_testsdebug.bat



.PHONY: W/*.bat examples/*


examples/sync_loop_windows.bat: 
	unix2dos examples/sync_loop_windows.bat
	scp imapsync examples/file.txt examples/sync_loop_windows.bat Admin@c:'C:/msys/1.0/home/Admin/imapsync/'
	ssh Admin@c 'C:/msys/1.0/home/Admin/imapsync/sync_loop_windows.bat --nodry --dry --nodry'


examples/infinite_loop_windows.bat:
	unix2dos examples/infinite_loop_windows.bat
	scp examples/infinite_loop_windows.bat Admin@c:'C:/msys/1.0/home/Admin/imapsync/'
	ssh Admin@c 'C:/msys/1.0/home/Admin/imapsync/infinite_loop_windows.bat'

W/test2.bat: 
	unix2dos W/test2.bat
	scp imapsync W/test2.bat Admin@c:'C:/msys/1.0/home/Admin/imapsync/'
	ssh Admin@c 'C:/msys/1.0/home/Admin/imapsync/test2.bat'

W/test3.bat:

=== debian/changelog ===
imapsync (2.229-1~deb10u1) buster; urgency=medium

  * Rebuild for buster.

 -- Raphaël Halimi <raphael.halimi@gmail.com>  Sat, 12 Aug 2023 13:21:51 +0200

imapsync (2.229-1) unstable; urgency=medium

  * Initial release.

 -- Raphaël Halimi <raphael.halimi@gmail.com>  Fri, 11 Aug 2023 15:18:37 +0200

=== debian/control ===
Source: imapsync
Section: mail
Priority: optional
Maintainer: Raphaël Halimi <raphael.halimi@gmail.com>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 12),
 cpanminus,
 lsb-release,
 procps,
 time,
 libauthen-ntlm-perl,
 libcgi-pm-perl,
 libcrypt-openssl-rsa-perl,
 libdata-uniqid-perl,
 libencode-imaputf7-perl,
 libfile-copy-recursive-perl,
 libfile-tail-perl,
 libio-socket-inet6-perl,
 libio-socket-ssl-perl,
 libio-tee-perl,
 libjson-webtoken-perl,
 libmail-imapclient-perl,
 libproc-processtable-perl,
 libmodule-scandeps-perl,
 libreadonly-perl,
 libregexp-common-perl,
 libsys-meminfo-perl,
 libterm-readkey-perl,
 libtest-mockobject-perl,
 libtest-pod-perl,
 libunicode-string-perl,
 libwww-perl,
 libtest-deep-perl,
 libtest-warn-perl,
 libdist-checkconflicts-perl,
 libmodule-implementation-perl,
 libmodule-runtime-conflicts-perl,
 libnet-https-any-perl,
 libpackage-stash-perl,
 libpackage-stash-xs-perl,
 libpar-packer-perl,
 libtest-fatal-perl,
 libtest-mock-guard-perl,
 libtest-requires-perl,
Standards-Version: 4.3.0
Homepage: https://github.com/imapsync/imapsync

Package: imapsync
Architecture: all
Depends:
 libauthen-ntlm-perl,
 libcgi-pm-perl,
 libcrypt-openssl-rsa-perl,
 libdata-uniqid-perl,
 libencode-imaputf7-perl,
 libfile-copy-recursive-perl,
 libfile-tail-perl,
 libio-socket-inet6-perl,
 libio-socket-ssl-perl,
 libio-tee-perl,
 libjson-webtoken-perl,
 libmail-imapclient-perl,
 libproc-processtable-perl,
 libmodule-scandeps-perl,
 libreadonly-perl,
 libregexp-common-perl,
 libsys-meminfo-perl,
 libterm-readkey-perl,
 libtest-mockobject-perl,
 libtest-pod-perl,
 libunicode-string-perl,
 libwww-perl,
 libtest-deep-perl,
 libtest-warn-perl,
 libdist-checkconflicts-perl,
 libmodule-implementation-perl,
 libmodule-runtime-conflicts-perl,
 libnet-https-any-perl,
 libpackage-stash-perl,
 libpackage-stash-xs-perl,
 libpar-packer-perl,
 libtest-fatal-perl,
 libtest-mock-guard-perl,
 libtest-requires-perl,
 ${misc:Depends},
Recommends:
 openssl,
 procps,
Description: IMAP transfer tool
 Command-line tool that allows incremental and recursive IMAP transfers from
 one mailbox to another, both anywhere on the internet or in your local
 network. The transfer can be stopped at any time and restarted later
 efficiently, without generating duplicates. The complete folders hierarchy
 can be copied, all folders, all subfolders etc.

=== debian/watch ===
# Watch file
# See uscan(1) for format.

# Compulsory line, this is a version 4 file.
version=4

# GitHub hosted projects.
https://github.com/imapsync/imapsync/tags (?:.*?/)@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@ debian uupdate
